/*  Eside 3D library, version 5.
    Copyright (C) 2002 Iker Jamardo Zugaza <ijamardo@eside.deusto.es>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    This library has been slightly modified by Grzegorz Adam Hankiewicz
    <gradha@terra.es> and is therefor not exactly the original, which you
    should be able to get from Iker by email.
*/

#ifndef _E3D_CRenderWOGL_h_
#define _E3D_CRenderWOGL_h_

#pragma warning (disable: 4786 4503)

#include "E3D_CRender.h"

#include <windows.h>
#include <gl/gl.h>

class CRenderWOGL: public CRender
{
public:
	// From CRender
	virtual bool init(void* window, int width, int height, bool fullscreen);
	virtual bool end();
	virtual bool startFrame();
	virtual bool flip();
	virtual bool endFrame();
	virtual bool setViewMatrix(float* viewMatrix);
	virtual bool pushModelMatrix(float* modelMatrix);
	virtual bool popModelMatrix();
	virtual bool renderModel();
	virtual bool renderBoundingBox(const CBoundingBox& bd);
	virtual int registerTexture(int width, int height, const void* data);
	virtual bool setTextureActive(int id);
	virtual bool setProjectionMatrix(float* matrix);
	virtual bool setViewport(int x, int y, int width, int height);

	// Own
	CRenderWOGL();
	~CRenderWOGL();

protected:
	GLenum E3D_MODE_TO_GL_MODE(E3D_MODE);
	GLuint createOGLTexture(GLint width, GLint height, const GLvoid* data);

	bool useGLUT;
	HWND hwnd;
	HDC hdc;
	HGLRC context;
	int width, height;

	float* viewMatrix;
};

#endif