/*  Eside 3D library, version 5.
    Copyright (C) 2002 Iker Jamardo Zugaza <ijamardo@eside.deusto.es>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    This library has been slightly modified by Grzegorz Adam Hankiewicz
    <gradha@terra.es> and is therefor not exactly the original, which you
    should be able to get from Iker by email.
*/

#include "E3D_CColor.h"

#include <sstream>
using std::stringstream;

CColor::operator string() const
{
	char buf[256];
	sprintf(buf, "(%f, %f, %f, %f)", a, r, g, b);
	return buf;
}

bool CColor::operator==(const CObject& obj) const
{
	return false;
}

bool CColor::fromString(const string& from)
{
	bool result = false;
	int index;
	string temp;
	string value;
	temp = from;
	index = temp.find_first_of("(");
	if (index != temp.npos)
	{
		temp = temp.substr(index + 1, temp.length() - index - 1);
		if ((index = temp.find_first_of(", ")) != temp.npos)
		{
			value = temp.substr(0, index);
			stringstream toA(value);
			toA >> a;
			temp = temp.substr(index + 2, temp.length() - index - 2);
			if ((index = temp.find_first_of(", ")) != temp.npos)
			{
				value = temp.substr(0, index);
				stringstream toR(value);
				toR >> r;
				temp = temp.substr(index + 2, temp.length() - index - 2);
				if ((index = temp.find_first_of(",")) != temp.npos)
				{
					value = temp.substr(0, index);
					stringstream toG(value);
					toG >> g;
					temp = temp.substr(index + 2, temp.length() - index - 2);
					if ((index = temp.find_first_of(")")) != temp.npos)
					{
						value = temp.substr(0, index);
						stringstream toB(value);
						toB >> b;
						result = true;
					}		
				}		
			}		
		}		
	}
	return result;
}

CColor::CColor(): a(0), r(0), g(0), b(0)
{
	typeName = "CColor";
}

CColor::CColor(float a, float r, float g, float b): a(a), r(r), g(g), b(b)
{
	typeName = "CColor";
}

