/*  Eside 3D library, version 5.
    Copyright (C) 2002 Iker Jamardo Zugaza <ijamardo@eside.deusto.es>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    This library has been slightly modified by Grzegorz Adam Hankiewicz
    <gradha@terra.es> and is therefor not exactly the original, which you
    should be able to get from Iker by email.
*/

#include "E3D_CShader.h"
#include "E3D_CGraph.h"
#include "E3D_CRender.h"
#include "E3D_IReader.h"
#include "E3D_IWriter.h"

DEFINE_CREATOR_OBJECT(CShader)

bool CShader::read(IReader* reader)
{
	string textureName;
	if (reader == NULL) return false;
	bool result = CBase::read(reader);
	if (result) result = reader->push("CShader");
	if (result) result = reader->read("TextureName", textureName);
	if (result) result = reader->pop("CShader");
	return result;
}

bool CShader::write(IWriter* writer)
{
	if (writer == NULL) return false;
	bool result = CBase::write(writer);
	if (result) result = writer->push("CShader");
	if (result) result = writer->write("TextureName", "NULL");
	if (result) result = writer->pop("CShader");
	return result;
}

bool CShader::connect(CGraph& graph)
{
	return true;
}

CShader::CShader()
{
	typeName = "CShader";
}

void CShader::setupToRender(CRender* render)
{
}
