/*  Eside 3D library, version 5.
    Copyright (C) 2002 Iker Jamardo Zugaza <ijamardo@eside.deusto.es>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    This library has been slightly modified by Grzegorz Adam Hankiewicz
    <gradha@terra.es> and is therefor not exactly the original, which you
    should be able to get from Iker by email.
*/

#include "E3D_CUVCoord.h"

#include <sstream>
using std::stringstream;

bool CUVCoord::operator==(const CObject& obj) const
{
	bool result = false;
	return result;
}

CUVCoord::operator string() const
{
	char buf[256];
	sprintf(buf, "(%f, %f)", u, v);
	return buf;
}

bool CUVCoord::fromString(const string& from)
{
	bool result = false;
	int index;
	string temp;
	string value;
	temp = from;
	index = temp.find_first_of("(");
	if (index != temp.npos)
	{
		temp = temp.substr(index + 1, temp.length() - index - 1);
		if ((index = temp.find_first_of(", ")) != temp.npos)
		{
			value = temp.substr(0, index);
			stringstream toU(value);
			toU >> u;
			temp = temp.substr(index + 2, temp.length() - index - 2);
			if ((index = temp.find_first_of(")")) != temp.npos)
			{
				value = temp.substr(0, index);
				stringstream toV(value);
				toV >> v;
				result = true;
			}		
		}		
	}
	return result;
}

CUVCoord::CUVCoord(): u(0), v(0)
{
	typeName = "CUVCoord";
}

CUVCoord::CUVCoord(float u, float v): u(u), v(v)
{
	typeName = "CUVCoord";
}

