/*  Eside 3D library, version 5.
    Copyright (C) 2002 Iker Jamardo Zugaza <ijamardo@eside.deusto.es>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    This library has been slightly modified by Grzegorz Adam Hankiewicz
    <gradha@terra.es> and is therefor not exactly the original, which you
    should be able to get from Iker by email.
*/

#ifndef _E3D_CANIMATIONCURVE_H_
#define _E3D_CANIMATIONCURVE_H_

#pragma warning (disable: 4786 4503)

#include "E3D_CBase.h"
#include "E3D_IReader.h"
#include "E3D_IWriter.h"

class IReader;
class IWriter;

class CKey: public CObject
{
public:
	float time;
	float value;

	bool operator==(const CKey& key);
	virtual bool read(IReader* reader);
	virtual bool write(IWriter* writer);
};

typedef vector<CKey> CKeyVector;
typedef CKeyVector::iterator CKeyVectorIterator;

class CAnimationCurve: public CBase
{
public:
	// From CBase
	virtual void update(float time);
	virtual float* getAttribute(const string& attributeName);
	virtual bool read(IReader* reader);
	virtual bool write(IWriter* writer);

	// Own
	CAnimationCurve();
	bool addKey(const CKey& key);

protected:
	float actualValue;
	CKeyVector keys;
};

DEFINE_CREATOR_CLASS(CAnimationCurve)

#endif