/*  Eside 3D library, version 5.
    Copyright (C) 2002 Iker Jamardo Zugaza <ijamardo@eside.deusto.es>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    This library has been slightly modified by Grzegorz Adam Hankiewicz
    <gradha@terra.es> and is therefor not exactly the original, which you
    should be able to get from Iker by email.
*/

#ifndef _E3D_CConnection_h_
#define _E3D_CConnection_h_

#include "E3D_CObject.h"

class CBase;
class IWriter;
class IReader;

class CConnection: public CObject
{
public:
// From CObject
	// ============================================================================
	// An operator to cast any object to a string. Polimorph it to give it a new
	// behaviour that fits your needs.
	// ============================================================================
	virtual operator string() const;

	// ============================================================================
	// An operator to compare the equality of two objects. Polimorph it to give
	// a new behaviour that fits your needs.
	// ============================================================================
	virtual bool operator==(const CObject& obj) const;

// Own
	CConnection();
	virtual bool read(IReader* reader);
	virtual bool write(IWriter* writer);

	bool isConnected();

	CBase* srcNode;
	string srcNodeName;
	float* srcAttribute;
	string srcAttributeName;
	CBase* dstNode;
	string dstNodeName;
	float* dstAttribute;
	string dstAttributeName;
};

typedef vector<CConnection*> pCConnectionVector;
typedef pCConnectionVector::iterator pCConnectionVectorIterator;

typedef vector<CConnection> CConnectionVector;
typedef CConnectionVector::iterator CConnectionVectorIterator;

#endif