/*  Eside 3D library, version 5.
    Copyright (C) 2002 Iker Jamardo Zugaza <ijamardo@eside.deusto.es>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    This library has been slightly modified by Grzegorz Adam Hankiewicz
    <gradha@terra.es> and is therefor not exactly the original, which you
    should be able to get from Iker by email.
*/

#ifndef _E3D_CSCENE_H_
#define _E3D_CSCENE_H_

#include "E3D_CTransform.h"
#include "E3D_CGraph.h"

class CCamera;

// ============================================================================
// A 3D scene storage class. Stores all the nodes that a scene has (to update)
// and the hierarchical first level of children.
// ============================================================================
class CScene: public CGraph
{
public:
// From CBase
	// ============================================================================
	// Updates any object. Polimorph it to give it your own behaivour.
	// In this case just updates all the nodes and the scene hierarchy.
	// ============================================================================
	virtual void update(float time);

// From CHierarchyBase
	// ============================================================================
	// Render hierarchically. 
	// Polimorph it to give it a new behaivour.
	// ============================================================================
	virtual void render(CRender* render);

// Own
	// ============================================================================
	// ============================================================================
	CScene();

	CTransform *getCTransform(const string &name);

	// ============================================================================
	// ============================================================================
	void setActualCamera(CCamera* camera);

protected:
	CCamera* actualCamera;
};

#endif