/*  Eside 3D library, version 5.
    Copyright (C) 2002 Iker Jamardo Zugaza <ijamardo@eside.deusto.es>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    This library has been slightly modified by Grzegorz Adam Hankiewicz
    <gradha@terra.es> and is therefor not exactly the original, which you
    should be able to get from Iker by email.
*/

#include "E3D_CInputButton.h"

CInputButton::CInputButton(): pressed(0)
{
	typeName = "CInputButton";
}

void CInputButton::setPressed(float pressed)
{
	changed = this->pressed != pressed;
	this->pressed = pressed;
}

float CInputButton::getPressed()
{
	return pressed;
}

const string CInputButton::BUTTON_NAME_NOBUTTON					="NOBUTTON"; 
const string CInputButton::BUTTON_NAME_BACK_SPACE				="BACK_SPACE";  
const string CInputButton::BUTTON_NAME_TAB							="TAB"; 
const string CInputButton::BUTTON_NAME_RETURN						="RETURN"; 
const string CInputButton::BUTTON_NAME_INTRO						="INTRO"; 
const string CInputButton::BUTTON_NAME_ESCAPE						="ESCAPE";  
const string CInputButton::BUTTON_NAME_CAPS_LOCK				="CAPS_LOCK";  

const string CInputButton::BUTTON_NAME_SHIFT_RIGHT			="SHIFT_RIGHT"; 
const string CInputButton::BUTTON_NAME_SHIFT_LEFT				="SHIFT_LEFT"; 
const string CInputButton::BUTTON_NAME_CONTROL_RIGHT		="CONTROL_RIGHT"; 
const string CInputButton::BUTTON_NAME_CONTROL_LEFT			="CONTROL_LEFT"; 
const string CInputButton::BUTTON_NAME_ALT_RIGHT				="ALT_RIGHT"; 
const string CInputButton::BUTTON_NAME_ALT_LEFT					="ALT_LEFT"; 
const string CInputButton::BUTTON_NAME_MENU							="MENU";   
const string CInputButton::BUTTON_NAME_LWIN							="LWIN";   
const string CInputButton::BUTTON_NAME_RWIN							="RWIN";   
const string CInputButton::BUTTON_NAME_NN								="";	 
                           
const string CInputButton::BUTTON_NAME_OPEN_BRANCH			="OPEN_BRANCH";  
const string CInputButton::BUTTON_NAME_CLOSE_BRANCH			="CLOSE_BRANCH";  
const string CInputButton::BUTTON_NAME_ARROWS						="ARROWS";  
const string CInputButton::BUTTON_NAME_COMMA						="COMMA";  
const string CInputButton::BUTTON_NAME_MINUS						="MINUS";  
const string CInputButton::BUTTON_NAME_POINT						="POINT";  
const string CInputButton::BUTTON_NAME_SLASH						="SLASH";  
const string CInputButton::BUTTON_NAME_BACK_QUOTE				="BACK_QUOTE";  
const string CInputButton::BUTTON_NAME_OPEN_BRACKET			="OPEN_BRACKET";  
const string CInputButton::BUTTON_NAME_CLOSE_BRACKET		="CLOSE_BRACKET";  
const string CInputButton::BUTTON_NAME_QUOTE						="QUOTE";  
const string CInputButton::BUTTON_NAME_SPACE						="SPACE";

const string CInputButton::BUTTON_NAME_PAGE_UP					="PAGE_UP";   
const string CInputButton::BUTTON_NAME_PAGE_DOWN				="PAGE_DOWN";   
const string CInputButton::BUTTON_NAME_END							="END"; 
const string CInputButton::BUTTON_NAME_HOME							="HOME"; 
const string CInputButton::BUTTON_NAME_LEFT							="LEFT"; 
const string CInputButton::BUTTON_NAME_UP								="UP"; 
const string CInputButton::BUTTON_NAME_RIGHT						="RIGHT"; 
const string CInputButton::BUTTON_NAME_DOWN							="DOWN"; 
const string CInputButton::BUTTON_NAME_INSERT						="INSERT"; 
const string CInputButton::BUTTON_NAME_DELETE						="DELETE"; 

const string CInputButton::BUTTON_NAME_0								="0"; 
const string CInputButton::BUTTON_NAME_1								="1"; 
const string CInputButton::BUTTON_NAME_2								="2"; 
const string CInputButton::BUTTON_NAME_3								="3"; 
const string CInputButton::BUTTON_NAME_4								="4"; 
const string CInputButton::BUTTON_NAME_5								="5"; 
const string CInputButton::BUTTON_NAME_6								="6"; 
const string CInputButton::BUTTON_NAME_7								="7";	
const string CInputButton::BUTTON_NAME_8								="8"; 
const string CInputButton::BUTTON_NAME_9								="9";	 

const string CInputButton::BUTTON_NAME_A								="A"; 
const string CInputButton::BUTTON_NAME_B								="B"; 
const string CInputButton::BUTTON_NAME_C								="C"; 
const string CInputButton::BUTTON_NAME_D								="D"; 
const string CInputButton::BUTTON_NAME_E								="E"; 
const string CInputButton::BUTTON_NAME_F								="F"; 
const string CInputButton::BUTTON_NAME_G								="G"; 
const string CInputButton::BUTTON_NAME_H								="H"; 
const string CInputButton::BUTTON_NAME_I								="I"; 
const string CInputButton::BUTTON_NAME_J								="J"; 
const string CInputButton::BUTTON_NAME_K								="K"; 
const string CInputButton::BUTTON_NAME_L								="L"; 
const string CInputButton::BUTTON_NAME_M								="M"; 
const string CInputButton::BUTTON_NAME_N								="N"; 
const string CInputButton::BUTTON_NAME_O								="O"; 
const string CInputButton::BUTTON_NAME_P								="P"; 
const string CInputButton::BUTTON_NAME_Q								="Q";	
const string CInputButton::BUTTON_NAME_R								="R"; 
const string CInputButton::BUTTON_NAME_S								="S"; 
const string CInputButton::BUTTON_NAME_T								="T"; 
const string CInputButton::BUTTON_NAME_U								="U"; 
const string CInputButton::BUTTON_NAME_V								="V"; 
const string CInputButton::BUTTON_NAME_W								="W"; 
const string CInputButton::BUTTON_NAME_X								="X"; 
const string CInputButton::BUTTON_NAME_Y								="Y"; 
const string CInputButton::BUTTON_NAME_Z								="Z"; 

const string CInputButton::BUTTON_NAME_NUMLOCK					="NUMLOCK";  
const string CInputButton::BUTTON_NAME_NUMPAD0					="NUMPAD0"; 
const string CInputButton::BUTTON_NAME_NUMPAD1					="NUMPAD1"; 
const string CInputButton::BUTTON_NAME_NUMPAD2					="NUMPAD2"; 
const string CInputButton::BUTTON_NAME_NUMPAD3					="NUMPAD3"; 
const string CInputButton::BUTTON_NAME_NUMPAD4					="NUMPAD4"; 
const string CInputButton::BUTTON_NAME_NUMPAD5					="NUMPAD5"; 
const string CInputButton::BUTTON_NAME_NUMPAD6					="NUMPAD6"; 
const string CInputButton::BUTTON_NAME_NUMPAD7					="NUMPAD7"; 
const string CInputButton::BUTTON_NAME_NUMPAD8					="NUMPAD8"; 
const string CInputButton::BUTTON_NAME_NUMPAD9					="NUMPAD9"; 
const string CInputButton::BUTTON_NAME_MULTIPLY					="MULTIPLY"; 
const string CInputButton::BUTTON_NAME_ADD							="ADD"; 
const string CInputButton::BUTTON_NAME_SUBSTRACT				="SUBSTRACT"; 
const string CInputButton::BUTTON_NAME_DECIMAL					="DECIMAL"; 
const string CInputButton::BUTTON_NAME_DIVIDE						="DIVIDE"; 

const string CInputButton::BUTTON_NAME_F1								="F1"; 
const string CInputButton::BUTTON_NAME_F2								="F2"; 
const string CInputButton::BUTTON_NAME_F3								="F3"; 
const string CInputButton::BUTTON_NAME_F4								="F4"; 
const string CInputButton::BUTTON_NAME_F5								="F5";	
const string CInputButton::BUTTON_NAME_F6								="F6"; 
const string CInputButton::BUTTON_NAME_F7								="F7"; 
const string CInputButton::BUTTON_NAME_F8								="F8"; 
const string CInputButton::BUTTON_NAME_F9								="F9";	 
const string CInputButton::BUTTON_NAME_F10							="F10"; 
const string CInputButton::BUTTON_NAME_F11							="F11"; 
const string CInputButton::BUTTON_NAME_F12							="F12"; 

const string CInputButton::BUTTON_NAME_PRINTSCREEN			="PRINTSCREEN";   
const string CInputButton::BUTTON_NAME_SCROLL_LOCK			="SCROLL_LOCK";  
const string CInputButton::BUTTON_NAME_PAUSE						="PAUSE";   

const string CInputButton::BUTTON_NAME_MOUSE_RIGHT			="MOUSE_RIGHT";
const string CInputButton::BUTTON_NAME_MOUSE_LEFT				="MOUSE_LEFT";
const string CInputButton::BUTTON_NAME_MOUSE_MIDDLE 		="MOUSE_MIDDLE";

const string CInputButton::BUTTON_NAME_JOYSTICK					="JOYSTICK";

const string CInputButton::BUTTON_NAME_PSXPAD_UP				="PSXPAD_UP";
const string CInputButton::BUTTON_NAME_PSXPAD_DOWN			="PSXPAD_DOWN";
const string CInputButton::BUTTON_NAME_PSXPAD_RIGHT			="PSXPAD_RIGHT";
const string CInputButton::BUTTON_NAME_PSXPAD_LEFT			="PSXPAD_LEFT";
const string CInputButton::BUTTON_NAME_PSXPAD_SQUARE		="PSXPAD_SQUARE";
const string CInputButton::BUTTON_NAME_PSXPAD_TRIANGLE	="PSXPAD_TRIANGLE";
const string CInputButton::BUTTON_NAME_PSXPAD_CIRCLE		="PSXPAD_CIRCLE";
const string CInputButton::BUTTON_NAME_PSXPAD_CROSS			="PSXPAD_CROSS";
const string CInputButton::BUTTON_NAME_PSXPAD_FRU				="PSXPAD_FRU";
const string CInputButton::BUTTON_NAME_PSXPAD_FRD				="PSXPAD_FRD";
const string CInputButton::BUTTON_NAME_PSXPAD_FLU				="PSXPAD_FLU";
const string CInputButton::BUTTON_NAME_PSXPAD_FLD				="PSXPAD_FLD";
