/*  Eside 3D library, version 5.
    Copyright (C) 2002 Iker Jamardo Zugaza <ijamardo@eside.deusto.es>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    This library has been slightly modified by Grzegorz Adam Hankiewicz
    <gradha@terra.es> and is therefor not exactly the original, which you
    should be able to get from Iker by email.
*/

#include "E3D_CInputCursor.h"

CInputCursor::CInputCursor(): posX(0),
															posY(0),
															posZ(0),
															incX(0),
															incY(0),
															incZ(0)
{
	typeName = "CInputCursor";
}

void CInputCursor::setPosX(float px)
{
	posX = px;
}

void CInputCursor::setPosY(float py)
{
	posY = py;
}

void CInputCursor::setPosZ(float pz)
{
	posZ = pz;
}

void CInputCursor::setIncX(float ix)
{
	incX = ix;
}

void CInputCursor::setIncY(float iy)
{
	incY = iy;
}

void CInputCursor::setIncZ(float iz)
{
	incZ = iz;
}

float CInputCursor::getPosX()
{
	return posX;
}

float CInputCursor::getPosY()
{
	return posY;
}

float CInputCursor::getPosZ()
{
	return posZ;
}

float CInputCursor::getIncX()
{
	return incX;
}

float CInputCursor::getIncY()
{
	return incY;
}

float CInputCursor::getIncZ()
{
	return incZ;
}

const string CInputCursor::CURSOR_NAME_MOUSE			= "MOUSE";
const string CInputCursor::CURSOR_NAME_JOYSTICK		= "JOYSTICK";
