/*  Eside 3D library, version 5.
    Copyright (C) 2002 Iker Jamardo Zugaza <ijamardo@eside.deusto.es>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    This library has been slightly modified by Grzegorz Adam Hankiewicz
    <gradha@terra.es> and is therefor not exactly the original, which you
    should be able to get from Iker by email.
*/

#ifndef _CINPUTBUTTON_H_
#define _CINPUTBUTTON_H_

#pragma warning (disable: 4786 4503)

#include "E3D_CInputElement.h"

#include <string>
using std::string;

class CInputButton: public CInputElement
{
public:
	CInputButton();
	void setPressed(float pressed);
	float getPressed();

	static const string BUTTON_NAME_NOBUTTON					;				
	static const string BUTTON_NAME_BACK_SPACE				;
	static const string BUTTON_NAME_TAB								;
	static const string BUTTON_NAME_RETURN						;
	static const string BUTTON_NAME_INTRO							;
	static const string BUTTON_NAME_ESCAPE						;
	static const string BUTTON_NAME_CAPS_LOCK					;

	static const string BUTTON_NAME_SHIFT_RIGHT				;
	static const string BUTTON_NAME_SHIFT_LEFT				;
	static const string BUTTON_NAME_CONTROL_RIGHT			;
	static const string BUTTON_NAME_CONTROL_LEFT			;
	static const string BUTTON_NAME_ALT_RIGHT					;
	static const string BUTTON_NAME_ALT_LEFT					;
	static const string BUTTON_NAME_MENU							;
	static const string BUTTON_NAME_LWIN							;
	static const string BUTTON_NAME_RWIN							;
	static const string BUTTON_NAME_NN								;
                             
	static const string BUTTON_NAME_OPEN_BRANCH				;
	static const string BUTTON_NAME_CLOSE_BRANCH			;
	static const string BUTTON_NAME_ARROWS						;
	static const string BUTTON_NAME_COMMA							;
	static const string BUTTON_NAME_MINUS							;
	static const string BUTTON_NAME_POINT							;
	static const string BUTTON_NAME_SLASH							;
	static const string BUTTON_NAME_BACK_QUOTE				;
	static const string BUTTON_NAME_OPEN_BRACKET			;
	static const string BUTTON_NAME_CLOSE_BRACKET			;
	static const string BUTTON_NAME_QUOTE							;
	static const string BUTTON_NAME_SPACE							;

	static const string BUTTON_NAME_PAGE_UP						;
	static const string BUTTON_NAME_PAGE_DOWN					;
	static const string BUTTON_NAME_END								;
	static const string BUTTON_NAME_HOME							;
	static const string BUTTON_NAME_LEFT							;
	static const string BUTTON_NAME_UP								;
	static const string BUTTON_NAME_RIGHT							;
	static const string BUTTON_NAME_DOWN							;
	static const string BUTTON_NAME_INSERT						;
	static const string BUTTON_NAME_DELETE						;

	static const string BUTTON_NAME_0									;
	static const string BUTTON_NAME_1									;
	static const string BUTTON_NAME_2									;
	static const string BUTTON_NAME_3									;
	static const string BUTTON_NAME_4									;
	static const string BUTTON_NAME_5									;
	static const string BUTTON_NAME_6									;
	static const string BUTTON_NAME_7									;
	static const string BUTTON_NAME_8									;
	static const string BUTTON_NAME_9									;

	static const string BUTTON_NAME_A									;
	static const string BUTTON_NAME_B									;
	static const string BUTTON_NAME_C									;
	static const string BUTTON_NAME_D									;
	static const string BUTTON_NAME_E									;
	static const string BUTTON_NAME_F									;
	static const string BUTTON_NAME_G									;
	static const string BUTTON_NAME_H									;
	static const string BUTTON_NAME_I									;
	static const string BUTTON_NAME_J									;
	static const string BUTTON_NAME_K									;
	static const string BUTTON_NAME_L									;
	static const string BUTTON_NAME_M									;
	static const string BUTTON_NAME_N									;
	static const string BUTTON_NAME_O									;
	static const string BUTTON_NAME_P									;
	static const string BUTTON_NAME_Q									;
	static const string BUTTON_NAME_R									;
	static const string BUTTON_NAME_S									;
	static const string BUTTON_NAME_T									;
	static const string BUTTON_NAME_U									;
	static const string BUTTON_NAME_V									;
	static const string BUTTON_NAME_W									;
	static const string BUTTON_NAME_X									;
	static const string BUTTON_NAME_Y									;
	static const string BUTTON_NAME_Z									;

	static const string BUTTON_NAME_NUMLOCK						;
	static const string BUTTON_NAME_NUMPAD0						;
	static const string BUTTON_NAME_NUMPAD1						;
	static const string BUTTON_NAME_NUMPAD2						;
	static const string BUTTON_NAME_NUMPAD3						;
	static const string BUTTON_NAME_NUMPAD4						;
	static const string BUTTON_NAME_NUMPAD5						;
	static const string BUTTON_NAME_NUMPAD6						;
	static const string BUTTON_NAME_NUMPAD7						;
	static const string BUTTON_NAME_NUMPAD8						;
	static const string BUTTON_NAME_NUMPAD9						;
	static const string BUTTON_NAME_MULTIPLY					;
	static const string BUTTON_NAME_ADD								;
	static const string BUTTON_NAME_SUBSTRACT					;
	static const string BUTTON_NAME_DECIMAL						;
	static const string BUTTON_NAME_DIVIDE						;

	static const string BUTTON_NAME_F1								;
	static const string BUTTON_NAME_F2								;
	static const string BUTTON_NAME_F3								;
	static const string BUTTON_NAME_F4								;
	static const string BUTTON_NAME_F5								;
	static const string BUTTON_NAME_F6								;
	static const string BUTTON_NAME_F7								;
	static const string BUTTON_NAME_F8								;
	static const string BUTTON_NAME_F9								;
	static const string BUTTON_NAME_F10								;
	static const string BUTTON_NAME_F11								;
	static const string BUTTON_NAME_F12								;

	static const string BUTTON_NAME_PRINTSCREEN				;
	static const string BUTTON_NAME_SCROLL_LOCK				;
	static const string BUTTON_NAME_PAUSE							;

	static const string BUTTON_NAME_MOUSE_RIGHT				;
	static const string BUTTON_NAME_MOUSE_LEFT				;
	static const string BUTTON_NAME_MOUSE_MIDDLE 			;

	static const string BUTTON_NAME_JOYSTICK					;

	static const string BUTTON_NAME_PSXPAD_UP					;
	static const string BUTTON_NAME_PSXPAD_DOWN				;
	static const string BUTTON_NAME_PSXPAD_RIGHT			;
	static const string BUTTON_NAME_PSXPAD_LEFT				;
	static const string BUTTON_NAME_PSXPAD_SQUARE			;
	static const string BUTTON_NAME_PSXPAD_TRIANGLE		;
	static const string BUTTON_NAME_PSXPAD_CIRCLE			;
	static const string BUTTON_NAME_PSXPAD_CROSS			;
	static const string BUTTON_NAME_PSXPAD_FRU				;
	static const string BUTTON_NAME_PSXPAD_FRD				;
	static const string BUTTON_NAME_PSXPAD_FLU				;
	static const string BUTTON_NAME_PSXPAD_FLD				;

protected:
	float pressed;
};

typedef map<string, CInputButton*> stringPCInputButtonMap;
typedef stringPCInputButtonMap::iterator stringPCInputButtonMapIterator;

#endif