/*  Eside 3D library, version 5.
    Copyright (C) 2002 Iker Jamardo Zugaza <ijamardo@eside.deusto.es>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    This library has been slightly modified by Grzegorz Adam Hankiewicz
    <gradha@terra.es> and is therefor not exactly the original, which you
    should be able to get from Iker by email.
*/

#ifndef _CINPUTCURSOR_H_
#define _CINPUTCURSOR_H_

#pragma warning (disable: 4786 4503)

#include "E3D_CInputElement.h"

class CInputCursor: public CInputElement
{
public:
	CInputCursor();
	void setPosX(float px);
	void setPosY(float py);
	void setPosZ(float pz);
	void setIncX(float ix);
	void setIncY(float iy);
	void setIncZ(float iz);
	float getPosX();
	float getPosY();
	float getPosZ();
	float getIncX();
	float getIncY();
	float getIncZ();

	static const string CURSOR_NAME_MOUSE;
	static const string CURSOR_NAME_JOYSTICK;

protected:
	float incX, incY, incZ;
	float posX, posY, posZ;
};

typedef map<string, CInputCursor*> stringPCInputCursorMap;
typedef stringPCInputCursorMap::iterator stringPCInputCursorMapIterator;

#endif