/*  Eside 3D library, version 5.
    Copyright (C) 2002 Iker Jamardo Zugaza <ijamardo@eside.deusto.es>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    This library has been slightly modified by Grzegorz Adam Hankiewicz
    <gradha@terra.es> and is therefor not exactly the original, which you
    should be able to get from Iker by email.
*/

#ifndef _E3D_CINPUTDATA_H_
#define _E3D_CINPUTDATA_H_

#include "E3D_CInputButton.h"
#include "E3D_CInputCursor.h"

class CInputData: public CObject
{
public:
	CInputData(bool deleteAtEnd = true);
	~CInputData();
	bool addInputButton(CInputButton* button);
	bool addInputCursor(CInputCursor* cursor);
	void add(CInputData* iData);
	CInputButton* getInputButton(const string& name);
	CInputCursor* getInputCursor(const string& name);
	void end();
	void clear();

protected:
	bool deleteAtEnd;
	stringPCInputButtonMap buttons;
	stringPCInputCursorMap cursors;
};

#endif