/*  Eside 3D library, version 5.
    Copyright (C) 2002 Iker Jamardo Zugaza <ijamardo@eside.deusto.es>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    This library has been slightly modified by Grzegorz Adam Hankiewicz
    <gradha@terra.es> and is therefor not exactly the original, which you
    should be able to get from Iker by email.
*/

#ifndef _E3D_CINPUTDEVICE_H_
#define _E3D_CINPUTDEVICE_H_

#pragma warning (disable: 4786 4503)

#include "E3D_CInputData.h"

class CInputDevice: public CInputElement
{
public:
	CInputDevice();
	virtual ~CInputDevice();
	virtual void update(float time) = 0;
	virtual void setEnabled(bool enabled);
	virtual bool getEnabled();
	CInputData* getInputData();

	static const string DEVICE_NAME_KEYBOARD;
	static const string DEVICE_NAME_MOUSE;
	static const string DEVICE_NAME_JOYSTICK;
	static const string DEVICE_NAME_PSXPAD;

protected:
	bool enabled;
	CInputData inputData;
};

typedef map<string, CInputDevice*> stringPCInputDeviceMap;
typedef stringPCInputDeviceMap::iterator stringPCInputDeviceMapIterator;

#endif