/*  Eside 3D library, version 5.
    Copyright (C) 2002 Iker Jamardo Zugaza <ijamardo@eside.deusto.es>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    This library has been slightly modified by Grzegorz Adam Hankiewicz
    <gradha@terra.es> and is therefor not exactly the original, which you
    should be able to get from Iker by email.
*/

#ifndef _E3D_CINPUTDEVICEKEYBOARDW32_H_
#define _E3D_CINPUTDEVICEKEYBOARDW32_H_

#pragma warning (disable: 4786 4503)

#include "E3D_CInputDevice.h"

class CInputDeviceKeyboardW32: public CInputDevice
{
public:
// From CInputDevice
	virtual void update(float time);

// Own
	CInputDeviceKeyboardW32();

protected:
	enum BUTTON_CODE_W32
	{
		BUTTON_CODE_W32_NOBUTTON					= 0x00,
		BUTTON_CODE_W32_BACK_SPACE				= 0x08, 
		BUTTON_CODE_W32_TAB								= 0x09,
		BUTTON_CODE_W32_RETURN						= 0x0D,
		BUTTON_CODE_W32_INTRO							= 0x0,
		BUTTON_CODE_W32_ESCAPE						= 0x0A, 
		BUTTON_CODE_W32_CAPS_LOCK					= 0x14, 

		BUTTON_CODE_W32_SHIFT_RIGHT				= 0x10,
		BUTTON_CODE_W32_SHIFT_LEFT				= 0x10,
		BUTTON_CODE_W32_CONTROL_RIGHT			= 0x11,
		BUTTON_CODE_W32_CONTROL_LEFT			= 0x11,
		BUTTON_CODE_W32_ALT_RIGHT					= 0x0,
		BUTTON_CODE_W32_ALT_LEFT					= 0x0,
		BUTTON_CODE_W32_MENU							= 0x12, 
		BUTTON_CODE_W32_LWIN							= 0x5B, 
		BUTTON_CODE_W32_RWIN							= 0x5C, 
		BUTTON_CODE_W32_NN								= 0x5D,	
                           
		BUTTON_CODE_W32_OPEN_BRANCH				= 0x15, 
		BUTTON_CODE_W32_CLOSE_BRANCH			= 0x16, 
		BUTTON_CODE_W32_ARROWS						= 0x17, 
		BUTTON_CODE_W32_COMMA							= 0x18, 
		BUTTON_CODE_W32_MINUS							= 0x19, 
		BUTTON_CODE_W32_POINT							= 0x1A, 
		BUTTON_CODE_W32_SLASH							= 0x1B, 
		BUTTON_CODE_W32_BACK_QUOTE				= 0x1C, 
		BUTTON_CODE_W32_OPEN_BRACKET			= 0x1D, 
		BUTTON_CODE_W32_CLOSE_BRACKET			= 0x1E, 
		BUTTON_CODE_W32_QUOTE							= 0x1F, 
		BUTTON_CODE_W32_SPACE							= 0x20,

		BUTTON_CODE_W32_PAGE_UP						= 0x21, 
		BUTTON_CODE_W32_PAGE_DOWN					= 0x22, 
		BUTTON_CODE_W32_END								= 0x23,
		BUTTON_CODE_W32_HOME							= 0x24,
		BUTTON_CODE_W32_LEFT							= 0x25,
		BUTTON_CODE_W32_UP								= 0x26,
		BUTTON_CODE_W32_RIGHT							= 0x27,
		BUTTON_CODE_W32_DOWN							= 0x28,
		BUTTON_CODE_W32_INSERT						= 0x2D,
		BUTTON_CODE_W32_DELETE						= 0x2E,

		BUTTON_CODE_W32_0									= 0x30,
		BUTTON_CODE_W32_1									= 0x31,
		BUTTON_CODE_W32_2									= 0x32,
		BUTTON_CODE_W32_3									= 0x33,
		BUTTON_CODE_W32_4									= 0x34,
		BUTTON_CODE_W32_5									= 0x35,
		BUTTON_CODE_W32_6									= 0x36,
		BUTTON_CODE_W32_7									= 0x37,
		BUTTON_CODE_W32_8									= 0x38,
		BUTTON_CODE_W32_9									= 0x39,

		BUTTON_CODE_W32_A									= 0x41,
		BUTTON_CODE_W32_B									= 0x42,
		BUTTON_CODE_W32_C									= 0x43,
		BUTTON_CODE_W32_D									= 0x44,
		BUTTON_CODE_W32_E									= 0x45,
		BUTTON_CODE_W32_F									= 0x46,
		BUTTON_CODE_W32_G									= 0x47,
		BUTTON_CODE_W32_H									= 0x48,
		BUTTON_CODE_W32_I									= 0x49,
		BUTTON_CODE_W32_J									= 0x4A,
		BUTTON_CODE_W32_K									= 0x4B,
		BUTTON_CODE_W32_L									= 0x4C,
		BUTTON_CODE_W32_M									= 0x4D,
		BUTTON_CODE_W32_N									= 0x4E,
		BUTTON_CODE_W32_O									= 0x4F,
		BUTTON_CODE_W32_P									= 0x50,
		BUTTON_CODE_W32_Q									= 0x51,
		BUTTON_CODE_W32_R									= 0x52,
		BUTTON_CODE_W32_S									= 0x53,
		BUTTON_CODE_W32_T									= 0x54,
		BUTTON_CODE_W32_U									= 0x55,
		BUTTON_CODE_W32_V									= 0x56,
		BUTTON_CODE_W32_W									= 0x57,
		BUTTON_CODE_W32_X									= 0x58,
		BUTTON_CODE_W32_Y									= 0x59,
		BUTTON_CODE_W32_Z									= 0x5A,

		BUTTON_CODE_W32_NUMLOCK						= 0x5F, 
		BUTTON_CODE_W32_NUMPAD0						= 0x60,
		BUTTON_CODE_W32_NUMPAD1						= 0x61,
		BUTTON_CODE_W32_NUMPAD2						= 0x62,
		BUTTON_CODE_W32_NUMPAD3						= 0x63,
		BUTTON_CODE_W32_NUMPAD4						= 0x64,
		BUTTON_CODE_W32_NUMPAD5						= 0x65,
		BUTTON_CODE_W32_NUMPAD6						= 0x66,
		BUTTON_CODE_W32_NUMPAD7						= 0x67,
		BUTTON_CODE_W32_NUMPAD8						= 0x68,
		BUTTON_CODE_W32_NUMPAD9						= 0x69,
		BUTTON_CODE_W32_MULTIPLY					= 0x6A,
		BUTTON_CODE_W32_ADD								= 0x6B,
		BUTTON_CODE_W32_SUBSTRACT					= 0x6D,
		BUTTON_CODE_W32_DECIMAL						= 0x6E,
		BUTTON_CODE_W32_DIVIDE						= 0x6F,	

		BUTTON_CODE_W32_F1								= 0x70,
		BUTTON_CODE_W32_F2								= 0x71,
		BUTTON_CODE_W32_F3								= 0x72,
		BUTTON_CODE_W32_F4								= 0x73,
		BUTTON_CODE_W32_F5								= 0x74,
		BUTTON_CODE_W32_F6								= 0x75,
		BUTTON_CODE_W32_F7								= 0x76,
		BUTTON_CODE_W32_F8								= 0x77,
		BUTTON_CODE_W32_F9								= 0x78,
		BUTTON_CODE_W32_F10								= 0x79,
		BUTTON_CODE_W32_F11								= 0x7A,
		BUTTON_CODE_W32_F12								= 0x7B,

		BUTTON_CODE_W32_PRINTSCREEN				= 0x2C, 
		BUTTON_CODE_W32_SCROLL_LOCK				= 0x7C, 
		BUTTON_CODE_W32_PAUSE							= 0x13,
	};

	typedef map<BUTTON_CODE_W32, string> BUTTON_CODE_W32StringMap;
	typedef BUTTON_CODE_W32StringMap::iterator BUTTON_CODE_W32StringMapIterator;

	BUTTON_CODE_W32StringMap W32ButtonMap;
};

#endif