/*  Eside 3D library, version 5.
    Copyright (C) 2002 Iker Jamardo Zugaza <ijamardo@eside.deusto.es>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    This library has been slightly modified by Grzegorz Adam Hankiewicz
    <gradha@terra.es> and is therefor not exactly the original, which you
    should be able to get from Iker by email.
*/

#ifndef _E3D_CReaderASCII_h_
#define _E3D_CReaderASCII_h_

#include "E3D_CObject.h"
#include "E3D_IReader.h"

#include <fstream>
using std::ifstream;

class CReaderASCII: public CObject, public IReader
{
public:
	// From IReader
	virtual bool open(const string& file);
	virtual bool close();
	virtual bool push(const string& name);
	virtual bool pop(const string& name);
	virtual bool read(const string& name);
	virtual bool read(const string& name, float& value);
	virtual bool read(const string& name, int& value);
	virtual bool read(const string& name, CMatrix4D& value);
	virtual bool read(const string& name, CVector3D& value);
	virtual bool read(const string& name, CColor& value);
	virtual bool read(const string& name, CUVCoord& value);
	virtual bool read(const string& name, string& value);
protected:
	bool findLine(const string& patern, string& line);
	bool getValueString(const string& name, string& valueString);
	ifstream ifs;
};

#endif