/*  Eside 3D library, version 5.
    Copyright (C) 2002 Iker Jamardo Zugaza <ijamardo@eside.deusto.es>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    This library has been slightly modified by Grzegorz Adam Hankiewicz
    <gradha@terra.es> and is therefor not exactly the original, which you
    should be able to get from Iker by email.
*/

#ifndef _E3D_IWriter_h_
#define _E3D_IWriter_h_

class CMatrix4D;
class CVector3D;
class CColor;
class CUVCoord;

class IWriter
{
public:
	virtual ~IWriter() { }
	virtual bool open(const string& file) = 0;
	virtual bool close() = 0;
	virtual bool push(const string& name) = 0;
	virtual bool pop(const string& name) = 0;
	virtual bool write(const string& name) = 0;
	virtual bool write(const string& name, const float& value) = 0;
	virtual bool write(const string& name, const int& value) = 0;
	virtual bool write(const string& name, const CMatrix4D& value) = 0;
	virtual bool write(const string& name, const CVector3D& value) = 0;
	virtual bool write(const string& name, const CColor& value) = 0;
	virtual bool write(const string& name, const CUVCoord& value) = 0;
	virtual bool write(const string& name, const string& value) = 0;
};

#endif