/*  Katapult, version 1.
    Copyright (C) 2002 Grzegorz Adam Hankiewicz <gradha@terra.es> and
    Jon Lpez de Dicastillo <darwater@hotmail.com>.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef EARTH_H
#define EARTH_H

#include "E3D_CMesh.h"

class CShader;
class CScene;

class CEarth
{
private:
	float w, h;
	CMesh *mesh;

public:
	CEarth(CScene &scene, float width, float height);
	~CEarth();
	// needed to insert it in the scene
	float width(void);
	float height(void);

	CVector3D zone(int num, int corner = 0);
	float zoneWidth(void);
	float zoneHeight(void);
};

// Size/location of the players' arenas
#define ZONE_BOTTOM		0.1f
#define ZONE_TOP		0.3f
#define ZONE_WIDTH		0.7f


#endif EARTH_H
