/*  Katapult, version 1.
    Copyright (C) 2002 Grzegorz Adam Hankiewicz <gradha@terra.es> and
    Jon Lpez de Dicastillo <darwater@hotmail.com>.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef KARRO_H
#define KARRO_H

#include <string>
using std::string;

class CScene;
class CTransform;
class CVector3D;
class CMesh;
class CBoundingBox;

class CKarro
{
	private:
		CTransform *tBase, *tPala, *tProy;
		string nombre;
		CMesh *meshBase, *meshPala, *meshProy;
		float power, startTime, endTime;
		int z, nextState;

	public:
		CKarro(CScene &scene, const string &nombre, int zone);
		~CKarro();
		// places the object at the specified position
		void move(const CVector3D &pos);
		// rotate it's weapon, angle given in radians
		void angle(float angle);
		// get actual position
		CVector3D position(void);
		// get actual angle rotation
		float angle(void);
		// get zone value
		int zone(void);
		int getRecorrido(float time, CVector3D &posBala, int &freezeCamera);
		// devuelve el vector de translacion correspondiente
		void disparar(float power, float startTime, float endTime, int nextState);
		// Efectua el disparo
		CVector3D getPosBala(void);
		CBoundingBox getBoundingBox(void);
		CBoundingBox getBalaBoundingBox(void);
		void destruir(float startTime, float endTime, int nextState);
		void destruyendo (float time);
};


#endif